#include <stdio.h>

// Вызовы конструкторов с разными вариантами параметров
// функций и типов возвращаемых значений
// компилировать  g++ test -fno-alide-constructors
// сравните с вариантом компиляции  g++ test 


class ABC
{
    int x;
 public:
    ABC(int xx = 0) { x=xx; printf("ABC()\n"); }
    ABC(const ABC & a) { x = a.x; printf("ABC()-copy\n"); }
    ~ABC() { printf("ABC-destructor\n"); }
    void operator++() { ++x; }
    void print(const char *text) { printf("%s  x=%d\n",text, x); }
};

ABC f1 (ABC a) 
{
   ++a;
   return a;
}

ABC f2 (ABC &a) 
{
   ++a;
   return a;
}

ABC & f3 (ABC & a) 
{
   ++a;
   return a;
}

ABC g1()
{
   ABC a(10);
   return a;
}

ABC g2()
{
   return ABC(10);
}

int main ()
{
   ABC a, b;

   printf("-----------\n");
   b = f1(a);
   b.print("f1");
   printf("-----------\n");
   b = f2(a);
   b.print("f2");
   printf("-----------\n");
   b = f3(a);
   b.print("f3");
   printf("-----------\n");
   b = g1();
   b.print("g1");
   printf("-----------\n");
   b = g2();
   b.print("g2");
   printf("-----------\n");

   return 0;
}


